#include <stdio.h>
#include "defines.h"
#include "aiggraph.h"

int pixhead(FILE *fp,int xsize,int ysize,int fpal)
/* ＰＩＸヘッダー書き出し：Ｏｈ！Ｘ１９９０／６月号ｐ７０参照のこと */
{
int flen,i;
unsint x,pal[16];
	/* マッチストリング */
	fputs("TX16",fp);
	
	/* ファイルサイズ−８ */
	flen=((xsize+15)/16)*2*ysize*4+48-8;
	fwrite(&flen,sizeof(flen),1,fp);
	
	/* dummy */
	flen=0;
	fwrite(&flen,sizeof(flen),1,fp);
	
	/* 横ドット数 */
	if (xsize<128||xsize>640) return(-1);
	x=xsize;
	fwrite(&x,sizeof(short),1,fp);
	/* 縦ライン数 */
	if (ysize<64||ysize>480) return(-2);
	x=ysize;
	fwrite(&x,sizeof(short),1,fp);
	
	/* パレット */
	for (i=0;i<16;i++) {
		if (fpal) {
			pal[i]=RDGPAL1(i); /* 現在のパレット情報を読み出す */
		} else {
			pal[i]=rgb(Def_16_Pal[i][0],Def_16_Pal[i][1],Def_16_Pal[i][2]);
		}
	}
	fwrite(pal,sizeof(pal),1,fp);
	
	return(ferror(fp));
}
